.386P

.model flat, STDCALL
include win32.inc
include dialer.inc

IDD_DIALOG      equ 103
IDD_DIALING     equ 104
MAX_LEN         equ 16
IDC_NUMBER      equ 1010
IDC_PULSE       equ 1013
IDC_TONE        equ 1012
IDC_WAITTONE    equ 1014
IDC_BUTTON1     equ 1001
IDC_BUTTON10    equ 1000
IDI_ICON        equ 102
IDC_DIALSTR     equ 105
IDC_STATICIMG   equ 106

extrn           CheckDlgButton:PROC
extrn           DialogBoxParamA:PROC
extrn           EnableWindow:PROC
extrn           EndDialog:PROC
extrn           ExitProcess:PROC
extrn           GetDlgItem:PROC
extrn           GetDlgItemTextA:PROC
extrn           GetModuleHandleA:PROC
extrn           IsDlgButtonChecked:PROC
extrn           lineClose:PROC
extrn           lineDeallocateCall:PROC
extrn           lineDrop:PROC
extrn           lineInitializeExA:PROC
extrn           lineMakeCallA:PROC
extrn           lineNegotiateAPIVersion:PROC
extrn           lineOpenA:PROC
extrn           lineShutdown:PROC
extrn           LoadIconA:PROC
extrn           MessageBoxA:PROC
extrn           SendDlgItemMessageA:PROC
extrn           SendMessageA:PROC
extrn           SetClassLongA:PROC
extrn           SetDlgItemTextA:PROC
extrn           SetFocus:PROC

.data

szError1        db          '   lineInitializeEx',0
szError2        db          '   lineNegotiateAPIVersion',0
szError3        db          '   lineOpen',0
szError4        db          '   lineMakeCall',0
pulse           dd          1
wait            dd          1
prefix          db          ' ',' '
number          db MAX_LEN + 1 dup(0)
template        db          '0x00000000',0
digits          db          '0123456789ABCDEF'
APIVersion      dd          00020000h
lineParams      LINEINITIALIZEEXPARAMS <?>
extID           LINEEXTENSIONID <?>
call            dd          ?
hInst           dd          ?
lineApp         dd          ?
line            dd          ?
numDevs         dd          ?

.code

start:
        push    0
        call    GetModuleHandleA
        mov     [hInst], eax

        mov     [lineParams.dwOptions], LINEINITIALIZEEXOPTION_USEEVENT
        mov     eax, size lineParams
        mov     [lineParams.dwTotalSize], eax
        mov     [lineParams.dwUsedSize], eax
        mov     [lineParams.dwNeededSize], eax

        push    offset lineParams
        push    offset APIVersion
        push    offset numDevs
        push    0
        push    0
        push    [hInst]
        push    offset lineApp
        call    lineInitializeExA

        cmp     eax, 0
        jnl     initok
        push    offset szError1
        push    0
        call    Error
        jmp     exitprog
initok:

        push    offset extID
        push    offset APIVersion
        push    00040000h
        push    00010000h
        push    0
        push    [lineApp]
        call    lineNegotiateAPIVersion

        cmp     eax, 0
        jnl     negok
        push    offset szError2
        push    0
        call    Error
        jmp     exitprog
negok:

        push    0
        push    offset DlgProc
        push    0
        push    IDD_DIALOG
        push    [hInst]
        call    DialogBoxParamA

exitprog:
        push    [lineApp]
        call    lineShutdown
        push    0
        call    ExitProcess

strlen          proc str:DWORD
        cld
        mov     edi, [str]
        xor     al, al
        mov     ecx, 0100h
        repne   scasb
        mov     eax, 00FFh
        sub     eax, ecx
        ret
strlen          endp

itoa            proc
        mov     edi, offset template + 2
        mov     ecx, 8
        mov     edx, eax
l:      rol     edx, 4
        mov     ebx, edx
        and     ebx, 0000000Fh
        mov     al, digits[ebx]
        stosb
        loop    l
        ret
itoa            endp

Error           proc hdlg:DWORD, err:DWORD
        call    itoa
        push    MB_OK + MB_ICONHAND
        push    [err]
        push    offset template
        push    [hdlg]
        call    MessageBoxA
        ret
Error           endp

DialProc        proc uses ebx edi esi, hdlg:DWORD, wmsg:DWORD, wparam:DWORD, lparam:DWORD
        cmp     [wmsg], WM_COMMAND
        je      wmcommand
        cmp     [wmsg], WM_INITDIALOG
        jne     nocommand
        push    offset number
        push    IDC_DIALSTR
        push    [hdlg]
        call    SetDlgItemTextA
        push    IDI_ICON
        push    [hInst]
        call    LoadIconA
        push    eax
        push    IMAGE_ICON
        push    STM_SETIMAGE
        push    IDC_STATICIMG
        push    [hdlg]
        call    SendDlgItemMessageA
        mov     eax, 1
        jmp     endinit
wmcommand:
        mov     eax, [wparam]
        and     eax, 0000FFFFh
        cmp     eax, IDOK
        jne     nocommand
        push    0
        push    [hdlg]
        call    EndDialog
nocommand:
        mov     eax, 0
endinit:
        ret
DialProc        endp

DialNumber      proc hdlg:DWORD

        push    0
        push    0
        push    LINECALLPRIVILEGE_NONE
        push    0
        push    0
        push    [APIVersion]
        push    offset line
        push    0
        push    [lineApp]
        call    lineOpenA

        cmp     eax, 0
        jnl     openok
        push    offset szError3
        push    [hdlg]
        call    Error
        jmp     return
openok:

        mov     prefix, 'P'
        cmp     pulse, 1
        je      done
        mov     prefix, 'T'
done:   mov     [prefix + 1], ' '
        cmp     wait, 1
        jne     nowait
        mov     [prefix + 1], 'W'
nowait:

        push    0
        push    0
        push    offset prefix
        push    offset call
        push    [line]
        call    lineMakeCallA

        cmp     eax, 0
        jnl     callok
        push    [line]
        call    lineClose
        push    offset szError4
        push    [hdlg]
        call    Error
        jmp     return
callok:

        push    0
        push    offset DialProc
        push    0
        push    IDD_DIALING
        push    [hInst]
        call    DialogBoxParamA

        push    0
        push    0
        push    [call]
        call    lineDrop

        push    [call]
        call    lineDeallocateCall

        push    [line]
        call    lineClose

return:
        ret
DialNumber      endp

DlgProc         proc uses ebx edi esi, hdlg:DWORD, wmsg:DWORD, wparam:DWORD, lparam:DWORD

        cmp     [wmsg], WM_INITDIALOG
        je      wminitdialog

        cmp     [wmsg], WM_COMMAND
        jne     finish

        mov     eax, [wparam]
        mov     ebx, eax
        shr     ebx, 16
        and     eax, 0000FFFFh
        cmp     eax, IDCANCEL
        je      idcancel

        cmp     eax, IDOK
        je      idok

        cmp     eax, IDC_PULSE
        je      idcpulse

        cmp     eax, IDC_TONE
        je      idctone

        cmp     eax, IDC_WAITTONE
        je      idcwaittone

        cmp     eax, IDC_NUMBER
        je      idcnumber

        cmp     eax, IDC_BUTTON10
        jb      finish
        cmp     eax, IDC_NUMBER
        jae     finish
        push    eax
        push    offset number
        call    strlen
        cmp     eax, MAX_LEN
        jae     finish

        pop     eax
        sub     eax, 1000 - '0'
        dec     edi
        stosb
        xor     al, al
        stosb

        push    offset number
        push    IDC_NUMBER
        push    [hdlg]
        call    SetDlgItemTextA

        jmp     finish

idcancel:
        push    0
        push    [hdlg]
        call    EndDialog
        jmp     finish

idok:
        push    [hdlg]
        call    DialNumber
        jmp     finish

idcpulse:
        mov     pulse, 1
        jmp     finish

idctone:
        mov     pulse, 0
        jmp     finish

idcwaittone:
        push    IDC_WAITTONE
        push    [hdlg]
        call    IsDlgButtonChecked
        mov     wait, eax
        jmp     finish

idcnumber:
        cmp     ebx, EN_CHANGE
        jne     finish

        push    MAX_LEN + 1
        push    offset number
        push    IDC_NUMBER
        push    [hdlg]
        call    GetDlgItemTextA

        push    IDOK
        push    [hdlg]
        call    GetDlgItem

        xor     ebx, ebx
        mov     bl, number[0]
        push    ebx
        push    eax
        call    EnableWindow
        jmp     finish

wminitdialog:

        push    IDOK
        push    [hdlg]
        call    GetDlgItem

        push    0
        push    eax
        call    EnableWindow

        push    IDC_NUMBER
        push    [hdlg]
        call    GetDlgItem
        push    eax

        push    0
        push    MAX_LEN
        push    EM_LIMITTEXT
        push    eax
        call    SendMessageA

        push    pulse
        push    IDC_PULSE
        push    [hdlg]
        call    CheckDlgButton

        push    wait
        push    IDC_WAITTONE
        push    [hdlg]
        call    CheckDlgButton

        call    SetFocus

        push    IDI_ICON
        push    [hInst]
        call    LoadIconA

        push    eax
        push    GCL_HICON
        push    [hdlg]
        call    SetClassLongA

finish:
        mov     eax, 0
        ret
DlgProc         endp
ends
        end     start
